IKEv1 naspram IKEv2: autentifikacija unaprijed dijeljenim ključem i šta se razlikuje
Obje verzije dokazuju poznavanje unaprijed dijeljenog ključa bez slanja istog, ali šalju različite ulaze u različite heševe. Uporedite dva traga.
Dva gejtveja konfigurisana istim unaprijed dijeljenim ključem završavaju rukovanje, a hvatanje paketa ne pokazuje da tajna prelazi žicu. To je dio koji ljudi pamte. Zanimljiv dio je šta svaka verzija zaista izračunava da dokaže da je tajna poznata, jer IKEv1 i IKEv2 grade taj dokaz iz različitih ulaza i otkrivaju različite informacije dok to rade. Pročitajte dva traga jedan uz drugi i razlika prestaje biti kozmetička.
Šta dokaz mora postići
Diffie-Hellman daje obama partnerima zajedničku vrijednost čije javne polovine može izračunati i svako ko posmatra. To samo po sebi ne dokazuje ništa o identitetu: napadač koji završi razmjenu ključeva ima istu zajedničku vrijednost kao vaš gejtvej. Korak autentifikacije postoji da veže tu razmjenu za tajnu koju imaju samo predviđeni partneri, te za identitete i parametre o kojima su se dogovorili.
To vezivanje je razlog zašto heš pokriva više od ključa. Da pokriva samo tajnu, napadač bi ga mogao ponoviti u drugu razmjenu s različitim identitetima ili prijedlozima.
IKEv1 Main Mode: izvesti SKEYID, pa ga dokazati
Main Mode izvodi šest poruka. Prvi par pregovara sigurnosnu asocijaciju, drugi razmjenjuje Diffie-Hellman javne vrijednosti i nonceve, a treći nosi identitete plus autentifikacijske heševe pod enkripcijom koja je upravo uspostavljena. RFC 2409 definiše konstrukciju: uz autentifikaciju unaprijed dijeljenim ključem, SKEYID se izvodi iz tajne i oba noncea, a kasniji ključni materijal izvodi se iz SKEYID-a, Diffie-Hellman zajedničke vrijednosti, kolačića i konstanti.
Heš u petoj i šestoj poruci izračunava se nad Diffie-Hellman vrijednošću, dva kolačića, prijedlogom i identitetom pošiljaoca, s ključem SKEYID. Primalac ga ponovo izračunava sa svojom konfigurisanom tajnom. Neslaganje završava razmjenu i ni u jednom trenutku tajna sama nije korisni teret.
Aggressive Mode sabija isti posao u tri poruke, što znači da identiteti i autentifikacijski heš putuju prije nego što šifrovani kanal postoji. To je stvarna izloženost za tajnu koja se može pogoditi i odvojeno je od pitanja da li je tajna prenesena. IKEv1 je zastario prema RFC 9395, pa je naslijeđeni trag dijagnostička vježba, a ne cilj postavljanja.
IKEv2: drugačije izvođenje i drugačiji AUTH teret
IKEv2 ne koristi ponovo IKEv1 raspored ključeva. Početni IKE ključevi dolaze iz sjemena izgrađenog od nonceva i Diffie-Hellman zajedničke vrijednosti, a podređene sigurnosne asocijacije izvode se iz toga. Unaprijed dijeljeni ključ uopšte ne hrani sjeme.
Autentifikacija se zatim pojavljuje kao AUTH teret. Za autentifikaciju dijeljenim ključem RFC 7296 propisuje popunjenu formu tajne, koja nastaje heširanjem tajne s fiksnom niskom Key Pad for IKEv2, a zatim heširanjem potpisanih podataka razmjene i identiteta tim popunjenim ključem. Verifikator može ponovo izgraditi istu vrijednost; posmatrač ne može, bez tajne.
Primijetite šta se promijenilo. U IKEv1 tajna je ugrađena u raspored ključeva prije nego što autentifikacijski heš postoji; u IKEv2 raspored ključeva je nezavisan od tajne, a dokaz je poseban teret vezan za potpisane oktete. Isto konceptualno jamstvo, druga mašinerija, i zato se nazivi parametara i snimci ne preslikavaju jedan na jedan.
Šta posmatrač zaista nauči
Diffie-Hellman javne vrijednosti, prijedlozi, noncevi i kolačići vidljivi su u obje verzije. Identiteti su vidljivi u IKEv1 Aggressive Mode i zaštićeni u ostalim slučajevima. Tajna nikada nije vidljiva.
Ta posljednja rečenica ima granicu koju vrijedi navesti. Slaba tajna koju odabere čovjek može se napasti pogađanjem: napadač izračuna kakva bi bila autentifikacijska vrijednost za kandidata za tajnu i uporedi. IKEv1 Aggressive Mode to čini najjeftinijim jer su dokazi na otvorenom, a standardi općenito upozoravaju na tajne niske entropije. Nikada ne prenositi tajnu nije isto kao učiniti lošu tajnu sigurnom.
Šta učiniti s poređenjem
Koristite jedinstvenu tajnu za svaki par partnera, generišite je iz slučajnog izvora i mijenjajte je kroz istu putanju obezbjeđivanja koja ju je distribuirala. Ako je tajna pohranjena u konfiguracijskom predlošku koji se šalje u svaku poslovnicu, kompromis na jednom mjestu je kompromis svuda.
Preferirajte autentifikaciju zasnovanu na certifikatima gdje su operativni troškovi prihvatljivi, jer uklanja problem pogađanja dijeljene tajne i daje svakom partneru poseban identitet. Gdje unaprijed dijeljeni ključ ostaje, držite ga dugim, suzite njegov obim i tretirajte IKE verziju kao sigurnosnu odluku, a ne kao detalj interoperabilnosti.